﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SLAzureBlobInformation.AzureImageWCFService;
using System.Linq;
using System.Xml;
using System.Xml.Linq;
using System.Linq.Expressions; 

namespace SLAzureBlobInformation
{
    public partial class MainPage : UserControl
    {
        List<ImageInfo> listOfImages = new List<ImageInfo>();
        GetAzureStorageDataClient myServiceProxy = new GetAzureStorageDataClient();

        public MainPage()
        {
            InitializeComponent();
        }

        private void btnGetData_Click(object sender, RoutedEventArgs e)
        {
            myServiceProxy.GetDataCompleted += new EventHandler<GetDataCompletedEventArgs>(myServiceProxy_GetDataCompleted);
            myServiceProxy.GetDataAsync(); 
        }

        void myServiceProxy_GetDataCompleted(object sender, GetDataCompletedEventArgs e)
        {
            var returnBlobData = e.Result;

            XDocument blobXMLData = XDocument.Parse(returnBlobData);

            foreach (var p in blobXMLData.Descendants("Blob"))
            {
                ImageInfo tempImage = new ImageInfo();
                tempImage.imageName = p.Element("Name").Value;
                tempImage.imageURL = p.Element("Url").Value;
                listOfImages.Add(tempImage);

            };

            datagrdAzureBlobData.ItemsSource = listOfImages; 

        }
    }
}
