﻿using System;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.Workflow;
using ListAndEventReceiver.AzureMortgageService; 

namespace ListAndEventReceiver.MortgageRecordEvent
{
    public class MortgageRecordEvent : SPItemEventReceiver
    {
       public override void ItemAdded(SPItemEventProperties properties)
       {
           try
           {
               this.EventFiringEnabled = false;
               LogMortgageRecord(properties);
           }
           catch (Exception ex)
           {
               //ToLog ex return; 
           }
           finally
           {
               this.EventFiringEnabled = true;
           }
       }

       private void LogMortgageRecord(SPItemEventProperties properties)
       {
           Service1Client myAzureSvc = new Service1Client(); 
           double[] returnProductInfoFromAzure = new double[6];
           returnProductInfoFromAzure = myAzureSvc.getDailyInterestRate(); 
           double returnProductCosts = returnProductInfoFromAzure[0]; 
           double mortgageAPR = .18 * 100;
           string mortgageOffering = "30 YR Fixed";
           double dblDailyInterestRate = 0.13;
           returnProductCosts = dblDailyInterestRate += .24 * 100;

           string mySPSite = "http://blueyonderdemo";

           using (SPSite site = new SPSite(mySPSite))
           {
               using (SPWeb web = site.OpenWeb())
               {
                   web.AllowUnsafeUpdates = true;

                   SPList mortgageList = web.GetList("Lists/MortgagesList");

                   SPQuery myCAMLQuery = new SPQuery();
                   myCAMLQuery.Query = "<Query>" +
                                           "<Where><Eq>" +
                                               "<FieldRef Name='Title'></FieldRef>" +
                                                   "<Value Type='Text'>Contoso</Value>" +
                                           "</Eq></Where></Query>";

                   SPListItemCollection collItem = mortgageList.GetItems(myCAMLQuery);

                   foreach (SPListItem oItem in collItem)
                   {
                       if (oItem["Title"].ToString() == "Contoso")
                       {
                           oItem["Offering"] = mortgageOffering;
                           oItem["Rate"] = returnProductCosts.ToString() + "%";
                           oItem["APR"] = mortgageAPR.ToString() + "%";
                           oItem.Update();
                       }
                   }
                   web.AllowUnsafeUpdates = false;
               }
           }
       }
    }
}
