﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Data;
using MortgateWebPart.AzureService; 

namespace MortgateWebPart.MortgateInformation
{
    [ToolboxItemAttribute(false)]
    public class MortgateInformation : WebPart
    {
        Label titleLabel = new Label();
        DataGrid azureMortgageData = new DataGrid();
        LinkButton lnkbtnRefresh = new LinkButton();

        DataTable mortgageTable = new DataTable("Mortgage");
        DataColumn mortgageCol;
        DataRow mortgageRow;

        double[] returnMortgageData = new double[6];
        double mortgateAPR = .18;
        double[] pastMortgageRates = new double[6];

        string strTrend = "";

        protected override void CreateChildControls()
        {
            titleLabel.Text = "Contoso Mortgage Rates";
            lnkbtnRefresh.Text = "Refresh Data";
            this.Controls.Add(new LiteralControl("<table><tr><td>")); 
            this.Controls.Add(titleLabel);
            this.Controls.Add(new LiteralControl("</td></tr><tr><td>")); 
            this.Controls.Add(azureMortgageData);
            this.Controls.Add(new LiteralControl("</td></tr><tr><td>")); 
            this.Controls.Add(lnkbtnRefresh);
            this.Controls.Add(new LiteralControl("</td></tr><table>"));
            lnkbtnRefresh.Click += new EventHandler(lnkbtnRefresh_Click);
        }

        void lnkbtnRefresh_Click(object sender, EventArgs e)
        {
            loadDailyMortgageRates(); 
        }

        private void loadDailyMortgageRates()
        {
            createColumnHeadingsForTable();

            Service1Client myProxy = new Service1Client();
            returnMortgageData = myProxy.getDailyInterestRate();

            double dblDailyInterestRate = 0.13;

            for (int i = 0; i < 6; i++)
            {
                returnMortgageData[i] += dblDailyInterestRate;
            }


            pastMortgageRates[0] = .36;
            pastMortgageRates[1] = .34;
            pastMortgageRates[2] = .36;
            pastMortgageRates[3] = .32;
            pastMortgageRates[4] = .33;
            pastMortgageRates[5] = .28;

            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 1;
            mortgageRow["Products"] = "30 YR Fixed";
            mortgageRow["Rate"] = returnMortgageData[0].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[0]);
            mortgageRow["Change"] = (returnMortgageData[0] - pastMortgageRates[0]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[0], pastMortgageRates[0]);
            mortgageTable.Rows.Add(mortgageRow);

            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 2;
            mortgageRow["Products"] = "15 YR Fixed";
            mortgageRow["Rate"] = returnMortgageData[1].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[1]);
            mortgageRow["Change"] = (returnMortgageData[1] - pastMortgageRates[1]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[1], pastMortgageRates[1]);
            mortgageTable.Rows.Add(mortgageRow);

            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 3;
            mortgageRow["Products"] = "3/1 ARM";
            mortgageRow["Rate"] = returnMortgageData[2].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[2]);
            mortgageRow["Change"] = (returnMortgageData[2] - pastMortgageRates[2]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[2], pastMortgageRates[2]);
            mortgageTable.Rows.Add(mortgageRow);

            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 4;
            mortgageRow["Products"] = "5/1 ARM";
            mortgageRow["Rate"] = returnMortgageData[3].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[3]);
            mortgageRow["Change"] = (returnMortgageData[3] - pastMortgageRates[3]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[3], pastMortgageRates[3]);
            mortgageTable.Rows.Add(mortgageRow);

            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 5;
            mortgageRow["Products"] = "7/1 ARM";
            mortgageRow["Rate"] = returnMortgageData[4].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[4]);
            mortgageRow["Change"] = (returnMortgageData[4] - pastMortgageRates[4]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[4], pastMortgageRates[4]);
            mortgageTable.Rows.Add(mortgageRow);


            mortgageRow = mortgageTable.NewRow();
            mortgageRow["ID"] = 6;
            mortgageRow["Products"] = "10/1 ARM";
            mortgageRow["Rate"] = returnMortgageData[5].ToString();
            mortgageRow["APR"] = calculateAPR(returnMortgageData[5]);
            mortgageRow["Change"] = (returnMortgageData[5] - pastMortgageRates[5]).ToString();
            mortgageRow["Trend"] = calculateTrend(returnMortgageData[5], pastMortgageRates[5]);
            mortgageTable.Rows.Add(mortgageRow);

            azureMortgageData.DataSource = mortgageTable;
            azureMortgageData.DataBind(); 

        }

        private string calculateAPR(double mortgageRate)
        {
            double APR = mortgageRate + mortgateAPR;
            return APR.ToString();
        }

        private string calculateTrend(double currentMortgageRate, double pastMortgageRate)
        {
            double mortgageTrend = 0.00;

            mortgageTrend = currentMortgageRate - pastMortgageRate;

            if (mortgageTrend > 0.00)
            {
                strTrend = "+";
            }
            else if (mortgageTrend < 0.00)
            {
                strTrend = "-";
            }
            else if (mortgageTrend == 0.00)
            {
                strTrend = "NC";
            }

            return strTrend;
        }

        private void createColumnHeadingsForTable()
        {

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.Int32");
            mortgageCol.ColumnName = "ID";
            mortgageCol.Caption = "ID";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = true;
            mortgageTable.Columns.Add(mortgageCol);

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.String");
            mortgageCol.ColumnName = "Products";
            mortgageCol.Caption = "Products";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = false;
            mortgageTable.Columns.Add(mortgageCol);

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.String");
            mortgageCol.ColumnName = "Rate";
            mortgageCol.Caption = "Rate";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = false;
            mortgageTable.Columns.Add(mortgageCol);

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.String");
            mortgageCol.ColumnName = "APR";
            mortgageCol.Caption = "APR";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = false;
            mortgageTable.Columns.Add(mortgageCol);

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.String");
            mortgageCol.ColumnName = "Change";
            mortgageCol.Caption = "Change";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = false;
            mortgageTable.Columns.Add(mortgageCol);

            mortgageCol = new DataColumn();
            mortgageCol.DataType = System.Type.GetType("System.String");
            mortgageCol.ColumnName = "Trend";
            mortgageCol.Caption = "Trend";
            mortgageCol.ReadOnly = true;
            mortgageCol.Unique = false;
            mortgageTable.Columns.Add(mortgageCol);
        }
    }
}
