﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace GetContosoSalesData
{
    public class ContosoService : IContosoService
    {
        List<SalesData> returnAlStoresSalesData = new List<SalesData>();
        List<FiscalSalesData> returnFiscalSalesData = new List<FiscalSalesData>();
        ContosoEntities salesDataContext = new ContosoEntities();

        public List<SalesData> GetContosoStoreSales()
        {
            var salesData = from sales in salesDataContext.ContosoSales
                            select sales;

            foreach (var item in salesData)
            {
                SalesData tempSalesItem = new SalesData();
                tempSalesItem.StoreID = item.StoreID.ToString(); 
                tempSalesItem.StoreName = item.Store.ToString();
                tempSalesItem.FY09Sales = item.FY09.ToString();
                tempSalesItem.FY10Sales = item.FY10.ToString();
                tempSalesItem.FY11Sales = item.FY11.ToString();
                tempSalesItem.TotalSales = Convert.ToInt32(tempSalesItem.FY09Sales) + Convert.ToInt32(tempSalesItem.FY10Sales) + Convert.ToInt32(tempSalesItem.FY11Sales);

                returnAlStoresSalesData.Add(tempSalesItem); 
            }

            return returnAlStoresSalesData; 
        }

        public List<FiscalSalesData> GetFiscalSalesData()
        {
            var salesData = from sales in salesDataContext.ContosoSales
                            select sales;

            foreach (var item in salesData)
            {
                FiscalSalesData tempSalesItem = new FiscalSalesData();
                tempSalesItem.StoreID = item.StoreID.ToString();
                tempSalesItem.FY09Sales = item.FY09.ToString();
                tempSalesItem.FY10Sales = item.FY10.ToString();
                tempSalesItem.FY11Sales = item.FY11.ToString();
                returnFiscalSalesData.Add(tempSalesItem);
            }

            return returnFiscalSalesData; 
        }
    }
}
