﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightCharts
{
    public partial class MainPage : UserControl
    {
            int numOfSPOfferings = 5;
            int numOfVSOfferings = 9;
            int numOfSQLOfferings = 10;
            int numOfADVSPOfferings = 2;
            int numOfOFClientOfferings = 7;

        public MainPage()
        {
            InitializeComponent();
        }

        public class CourseData
        {
            public string TrainingCourse { get; set; }
            public int NumberOfCourses { get; set; }
        }

        public static List<CourseData> loadChartData(
            int numOfSPOfferings,
            int numOfVSOfferings,
            int numOfSQLOfferings,
            int numOfADVSPOfferings,
            int numOfOFClientOfferings)
        {

            List<CourseData> courseList = new List<CourseData>();

            courseList.Add(new CourseData() { NumberOfCourses = numOfSPOfferings, TrainingCourse = "SharePoint" });
            courseList.Add(new CourseData() { NumberOfCourses = numOfVSOfferings, TrainingCourse = "VS" });
            courseList.Add(new CourseData() { NumberOfCourses = numOfSQLOfferings, TrainingCourse = "SQL Server" });
            courseList.Add(new CourseData() { NumberOfCourses = numOfADVSPOfferings, TrainingCourse = "Adv. SP" });
            courseList.Add(new CourseData() { NumberOfCourses = numOfOFClientOfferings, TrainingCourse = "Off. Client" });

            return courseList; 
        }

        private void btnLoadData_Click(object sender, RoutedEventArgs e)
        {
            loadChartData(
                numOfSPOfferings,
                numOfVSOfferings,
                numOfSQLOfferings,
                numOfADVSPOfferings,
                numOfOFClientOfferings);
        }

    }
}
