﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using Resources; 
using System.Collections.Generic;
using Microsoft.ServiceBus;

namespace SharePointCallingSvc
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class SharePointCallingService : ISharePointCallingService
    {
        string svcNmspc = "your namespace here";
        string svcBusName = "owner";
        string svcBusSecret = "your secret key here";
        string svcName = "SPListenerService";

        public List<Sales> GetSales()
        {
            Uri svcURI = Microsoft.ServiceBus.ServiceBusEnvironment.CreateServiceUri("sb", svcNmspc, svcName);

            TransportClientEndpointBehavior svcBusCreds = new TransportClientEndpointBehavior();
            svcBusCreds.CredentialType = TransportClientCredentialType.SharedSecret;
            svcBusCreds.Credentials.SharedSecret.IssuerName = svcBusName;
            svcBusCreds.Credentials.SharedSecret.IssuerSecret = svcBusSecret;

            NetTcpRelayBinding binding = new NetTcpRelayBinding();

            ChannelFactory<ISalesDataChannel> channelFactory = new ChannelFactory<ISalesDataChannel>(binding, new EndpointAddress(svcURI));
            channelFactory.Endpoint.Behaviors.Add(svcBusCreds);
            ISalesDataChannel channel = channelFactory.CreateChannel();

            channel.Open();
            List<Sales> listFromOnPrem = channel.GetSales();
            channel.Close();

            return listFromOnPrem;

        } 
    }
}
