﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Activation;
using System.ServiceModel;
using CustomerBDCModel.CustomerDataFromAzure; 

namespace CustomerBDCModel.AzureCustomers
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class CustomerEntityService
    {

        #region Customer Methods

        public static CustomerEntity ReadItem(string id)
        {
            BasicHttpBinding mySvcbinding = new BasicHttpBinding();
            UriBuilder serviceURI = new UriBuilder("http://namespacehere.cloudapp.net/GetCustomers.svc");
            GetCustomersClient myWCFProxy = new GetCustomersClient(mySvcbinding, new EndpointAddress(serviceURI.Uri));

            var myCustomer = myWCFProxy.getACustomer(Int32.Parse(id));

            CustomerEntity entyCustomer = new CustomerEntity();

            entyCustomer.Identifier1 = myCustomer[0].custEmail.ToString();
            entyCustomer.custTitle = myCustomer[0].custFirstName.ToString();
            entyCustomer.custFirstName = myCustomer[0].custID.ToString();
            entyCustomer.custLastName = myCustomer[0].custLastName.ToString();
            entyCustomer.custEmail = myCustomer[0].custPhone.ToString();
            entyCustomer.custPhone = myCustomer[0].custTitle.ToString();             

            myWCFProxy.Close();

            return entyCustomer;
        }

        public static List<CustomerEntity> ReadList()
        {
            BasicHttpBinding mySvcbinding = new BasicHttpBinding();
            UriBuilder serviceURI = new UriBuilder("http://namespacehere.cloudapp.net/GetCustomers.svc");
            GetCustomersClient myWCFProxy = new GetCustomersClient(mySvcbinding, new EndpointAddress(serviceURI.Uri)); 

            var salesData = myWCFProxy.getAllCustomers();

            List<CustomerEntity> mySalesInfoList = new List<CustomerEntity>();

            foreach (var item in salesData)
            {
                CustomerEntity tempEntity = new CustomerEntity();
                tempEntity.Identifier1 = item.custID;
                tempEntity.custTitle = item.custTitle;
                tempEntity.custFirstName = item.custFirstName;
                tempEntity.custLastName = item.custLastName;
                tempEntity.custEmail = item.custEmail;
                tempEntity.custPhone = item.custPhone;
                mySalesInfoList.Add(tempEntity);
            }

            myWCFProxy.Close();

            return mySalesInfoList;
        }

        #endregion 

        #region GetCreditScore Method

        public int GetCreditScore()
        {
            try
            {
                int CreditScore = default(int);

                Random random = new Random();
                CreditScore = random.Next(550, 800);

                return CreditScore;
            }
            catch (Exception ex)
            {
                return 0;
            }
        }

        #endregion
    }
}
